<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/25/2003 *
 * ===============                              Last change: 07/01/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : modules.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : Main loader file. Loads our needed stuff         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Hauptladedatei. Laedt alle benoetigten Dateien   *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// APD call (if you have this apache extension and want to debug this script for us)
//apd_set_pprof_trace();

// Load security stuff here (Oh, I hope this is not unsecure? Am I paranoia??? ;-) )
require_once ("inc/libs/security_functions.php");

// Init "action" and "what"
global $what, $action, $startTime;
$GLOBALS['startTime'] = microtime(true);
$CSS = 0;
$GLOBALS['what'] = ""; $GLOBALS['action'] = "";
$GLOBALS['userid'] = 0;

if (!empty($_GET['action'])) $GLOBALS['action'] = secureString($_GET['action']);
if (!empty($_GET['what'])) $GLOBALS['what'] = secureString($_GET['what']);
if (empty($_GET['module'])) $_GET['module'] = "index";

// Secure the module name (very important line!)
$GLOBALS['module'] = htmlentities(strip_tags($_GET['module']), ENT_QUOTES);

// Needed include files
require ("inc/config.php");

// Check if logged in
if (IS_LOGGED_IN())
{
	// Is still logged in so we welcome him with his name
	$result = SQL_QUERY_ESC("SELECT surname, family FROM "._MYSQL_PREFIX."_user_data WHERE userid=%d LIMIT 1",
	 array($GLOBALS['userid']), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1)
	{
		// Load surname and family's name and build the username
		list($s, $f) = SQL_FETCHROW($result);
		$username = $s." ".$f;

		// Update only cookies and no login data!
		UPDATE_LOGIN_DATA(false);
	}
	 else
	{

		// Hmmm, logged in and no valid cookies???
		$username = "<I>"._UNKNOWN."</I>";
	}

	// Free memory
	SQL_FREERESULT($result);
}
 elseif (IS_ADMIN())
{
	$username = _ADMIN;
}
 else
{
	// He's a guest, hello there... ;-)
	$username = _GUEST;
}

// The header file
include (PATH."inc/header.php");

// Modules are by default not valid!
$MOD_VALID = false; $check = "failed";
if ((!empty($_CONFIG['maintenance'])) && ($_CONFIG['maintenance'] == "Y") && (!IS_ADMIN()) && ($GLOBALS['module'] != "admin"))
{
	// Maintain mode is active and you are no admin
	ADD_FATAL(LANG_DOWN_MAINTAINCE);
}
 elseif (($link) && ($db) && (sizeof($FATAL) == 0))
{
	// Did we found the module listed in allowed modules and are we successfully connected?
	$check = CHECK_MODULE($GLOBALS['module']);
	switch ($check)
	{
	case "admin_only":
	case "mem_only":
	case "done":
		// Construct module name
		define('__MODULE', sprintf(PATH."inc/modules/%s.php", $GLOBALS['module']));

		// Does the module exists on local file system?
		if (((file_exists(__MODULE)) || (!empty($URL))) && (sizeof($FATAL) == 0))
		{
			// Module is valid, active and located on the local disc...
			$MOD_VALID = true;
		}
		 elseif (!empty($URL))
		{
			// An URL was specified so we load the de-referrer module
			include (PATH."inc/loader.php");
		}
		 elseif (sizeof($FATAL) == 0)
		{
			ADD_FATAL(LANG_MOD_REG_404_1.$GLOBALS['module'].LANG_MOD_REG_404_2);
		}
		break;

	case "404":
		ADD_FATAL(LANG_MOD_REG_404_1.$GLOBALS['module'].LANG_MOD_REG_404_2);
		break;

	case "locked":
		if (!file_exists(PATH."inc/modules/".$GLOBALS['module'].".php"))
		{
			// Module does addionally not exists
			ADD_FATAL(LANG_MOD_REG_404_1.$GLOBALS['module'].LANG_MOD_REG_404_2);
		}
		ADD_FATAL(LANG_MOD_LOCKED_1.$GLOBALS['module'].LANG_MOD_LOCKED_2);
		break;

	default:
		ADD_FATAL(LANG_MOD_UNKNOWN_1.$check.LANG_MOD_UNKNOWN_2);
		break;
	}
}
 elseif (sizeof($FATAL) == 0)
{
	// MySQL problems!
	ADD_FATAL(MYSQL_ERRORS);
}

if ($MOD_VALID)
{
	/////////////////////////////////////////////
	// Main including line DO NOT REMOVE/EDIT! //
	/////////////////////////////////////////////
	//
	// Everything is okay so we can load the module
	include (__MODULE);
}

// Next-to-end add the footer
include (PATH."inc/footer.php");

//
?>
